part of mapmyindia_gl_platform_interface;

class MapmyIndiaGeoAnalyticsRequest {
  final String geoBound;
  final MapmyIndiageoAnalyticsAppearanceOption? style;

  MapmyIndiaGeoAnalyticsRequest({required this.geoBound, this.style});

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = {
      "geobound": geoBound,
    };
    if (style != null) {
      map['style'] = style?.toJson();
    }
    return map;
  }
}

class MapmyIndiageoAnalyticsAppearanceOption {
  final String? fillColor;
  final double? fillOpacity;
  final String? labelColor;
  final int? labelSize;
  final int? pointSize;
  final String? strokeColor;
  final double? strokeWidth;

  MapmyIndiageoAnalyticsAppearanceOption(
      {this.fillColor,
      this.fillOpacity,
      this.labelColor,
      this.labelSize,
      this.pointSize,
      this.strokeColor,
      this.strokeWidth});

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = {};
    void addIfPresent(String fieldName, dynamic value) {
      if (value != null) {
        map[fieldName] = value;
      }
    }

    addIfPresent('fillColor', fillColor);
    addIfPresent('fillOpacity', fillOpacity);
    addIfPresent('labelColor', labelColor);
    addIfPresent('labelSize', labelSize);
    addIfPresent('pointSize', pointSize);
    addIfPresent('strokeColor', strokeColor);
    addIfPresent('strokeWidth', strokeWidth);
    return map;
  }
}
